/*
 * WSO2 API Manager - Publisher API
 * This document specifies a **RESTful API** for WSO2 **API Manager** - **Publisher**.  # Authentication The Publisher REST API is protected using OAuth2 and access control is achieved through scopes. Before you start invoking the the API you need to obtain an access token with the required scopes. This guide will walk you through the steps that you will need to follow to obtain an access token. First you need to obtain the consumer key/secret key pair by calling the dynamic client registration (DCR) endpoint. You can add your preferred grant types in the payload. A Sample payload is shown below. ```   {   \"callbackUrl\":\"www.google.lk\",   \"clientName\":\"rest_api_publisher\",   \"owner\":\"admin\",   \"grantType\":\"client_credentials password refresh_token\",   \"saasApp\":true   } ``` Create a file (payload.json) with the above sample payload, and use the cURL shown bellow to invoke the DCR endpoint. Authorization header of this should contain the base64 encoded admin username and password. **Format of the request** ```   curl -X POST -H \"Authorization: Basic Base64(admin_username:admin_password)\" -H \"Content-Type: application/json\"   \\ -d @payload.json https://<host>:<servlet_port>/client-registration/v0.17/register ``` **Sample request** ```   curl -X POST -H \"Authorization: Basic YWRtaW46YWRtaW4=\" -H \"Content-Type: application/json\"   \\ -d @payload.json https://localhost:9443/client-registration/v0.17/register ``` Following is a sample response after invoking the above curl. ``` { \"clientId\": \"fOCi4vNJ59PpHucC2CAYfYuADdMa\", \"clientName\": \"rest_api_publisher\", \"callBackURL\": \"www.google.lk\", \"clientSecret\": \"a4FwHlq0iCIKVs2MPIIDnepZnYMa\", \"isSaasApplication\": true, \"appOwner\": \"admin\", \"jsonString\": \"{\\\"grant_types\\\":\\\"client_credentials password refresh_token\\\",\\\"redirect_uris\\\":\\\"www.google.lk\\\",\\\"client_name\\\":\\\"rest_api123\\\"}\", \"jsonAppAttribute\": \"{}\", \"tokenType\": null } ``` Next you must use the above client id and secret to obtain the access token. We will be using the password grant type for this, you can use any grant type you desire. You also need to add the proper **scope** when getting the access token. All possible scopes for publisher REST API can be viewed in **OAuth2 Security** section of this document and scope for each resource is given in **authorization** section of resource documentation. Following is the format of the request if you are using the password grant type. ``` curl -k -d \"grant_type=password&username=<admin_username>&password=<admin_passowrd&scope=<scopes seperated by space>\" \\ -H \"Authorization: Basic base64(cliet_id:client_secret)\" \\ https://<host>:<servlet_port>/oauth2/token ``` **Sample request** ``` curl https://localhost:9443/oauth2/token -k \\ -H \"Authorization: Basic Zk9DaTR2Tko1OVBwSHVjQzJDQVlmWXVBRGRNYTphNEZ3SGxxMGlDSUtWczJNUElJRG5lcFpuWU1h\" \\ -d \"grant_type=password&username=admin&password=admin&scope=apim:api_view apim:api_create\" ``` Shown below is a sample response to the above request. ``` { \"access_token\": \"e79bda48-3406-3178-acce-f6e4dbdcbb12\", \"refresh_token\": \"a757795d-e69f-38b8-bd85-9aded677a97c\", \"scope\": \"apim:api_create apim:api_view\", \"token_type\": \"Bearer\", \"expires_in\": 3600 } ``` Now you have a valid access token, which you can use to invoke an API. Navigate through the API descriptions to find the required API, obtain an access token as described above and invoke the API with the authentication header. If you use a different authentication mechanism, this process may change.  # Try out in Postman If you want to try-out the embedded postman collection with \"Run in Postman\" option, please follow the guidelines listed below. * All of the OAuth2 secured endpoints have been configured with an Authorization Bearer header with a parameterized access token. Before invoking any REST API resource make sure you run the `Register DCR Application` and `Generate Access Token` requests to fetch an access token with all required scopes. * Make sure you have an API Manager instance up and running. * Update the `basepath` parameter to match the hostname and port of the APIM instance.  [![Run in Postman](https://run.pstmn.io/button.svg)](https://app.getpostman.com/run-collection/a09044034b5c3c1b01a9) 
 *
 * The version of the OpenAPI document: v2
 * Contact: architecture@wso2.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.wso2.am.integration.clients.publisher.api.v1.dto;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.wso2.am.integration.clients.publisher.api.v1.dto.CustomAttributeDTO;
import org.wso2.am.integration.clients.publisher.api.v1.dto.SubscriptionThrottlePolicyPermissionDTO;
import org.wso2.am.integration.clients.publisher.api.v1.dto.ThrottleLimitDTO;
import com.fasterxml.jackson.annotation.JsonCreator;
/**
* SubscriptionPolicyAllOfDTO
*/

public class SubscriptionPolicyAllOfDTO {
        public static final String SERIALIZED_NAME_POLICY_ID = "policyId";
        @SerializedName(SERIALIZED_NAME_POLICY_ID)
            private Integer policyId = null;

        public static final String SERIALIZED_NAME_UUID = "uuid";
        @SerializedName(SERIALIZED_NAME_UUID)
            private String uuid;

        public static final String SERIALIZED_NAME_POLICY_NAME = "policyName";
        @SerializedName(SERIALIZED_NAME_POLICY_NAME)
            private String policyName;

        public static final String SERIALIZED_NAME_DISPLAY_NAME = "displayName";
        @SerializedName(SERIALIZED_NAME_DISPLAY_NAME)
            private String displayName;

        public static final String SERIALIZED_NAME_DESCRIPTION = "description";
        @SerializedName(SERIALIZED_NAME_DESCRIPTION)
            private String description;

        public static final String SERIALIZED_NAME_IS_DEPLOYED = "isDeployed";
        @SerializedName(SERIALIZED_NAME_IS_DEPLOYED)
            private Boolean isDeployed = false;

        public static final String SERIALIZED_NAME_TENANT_ID = "tenantId";
        @SerializedName(SERIALIZED_NAME_TENANT_ID)
            private Integer tenantId = null;

        public static final String SERIALIZED_NAME_TENANT_DOMAIN = "tenantDomain";
        @SerializedName(SERIALIZED_NAME_TENANT_DOMAIN)
            private String tenantDomain;

        public static final String SERIALIZED_NAME_DEFAULT_LIMIT = "defaultLimit";
        @SerializedName(SERIALIZED_NAME_DEFAULT_LIMIT)
            private ThrottleLimitDTO defaultLimit;

        public static final String SERIALIZED_NAME_RATE_LIMIT_COUNT = "rateLimitCount";
        @SerializedName(SERIALIZED_NAME_RATE_LIMIT_COUNT)
            private Integer rateLimitCount;

        public static final String SERIALIZED_NAME_RATE_LIMIT_TIME_UNIT = "rateLimitTimeUnit";
        @SerializedName(SERIALIZED_NAME_RATE_LIMIT_TIME_UNIT)
            private String rateLimitTimeUnit;

        public static final String SERIALIZED_NAME_SUBSCRIBER_COUNT = "subscriberCount";
        @SerializedName(SERIALIZED_NAME_SUBSCRIBER_COUNT)
            private Integer subscriberCount;

        public static final String SERIALIZED_NAME_CUSTOM_ATTRIBUTES = "customAttributes";
        @SerializedName(SERIALIZED_NAME_CUSTOM_ATTRIBUTES)
            private List<CustomAttributeDTO> customAttributes = null;

        public static final String SERIALIZED_NAME_STOP_ON_QUOTA_REACH = "stopOnQuotaReach";
        @SerializedName(SERIALIZED_NAME_STOP_ON_QUOTA_REACH)
            private Boolean stopOnQuotaReach = false;

        public static final String SERIALIZED_NAME_BILLING_PLAN = "billingPlan";
        @SerializedName(SERIALIZED_NAME_BILLING_PLAN)
            private String billingPlan;

        public static final String SERIALIZED_NAME_PERMISSIONS = "permissions";
        @SerializedName(SERIALIZED_NAME_PERMISSIONS)
            private SubscriptionThrottlePolicyPermissionDTO permissions;


        public SubscriptionPolicyAllOfDTO policyId(Integer policyId) {
        
        this.policyId = policyId;
        return this;
        }

    /**
        * Id of policy
    * @return policyId
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "1", value = "Id of policy")
    
    public Integer getPolicyId() {
        return policyId;
    }


    public void setPolicyId(Integer policyId) {
        this.policyId = policyId;
    }


        public SubscriptionPolicyAllOfDTO uuid(String uuid) {
        
        this.uuid = uuid;
        return this;
        }

    /**
        * policy uuid
    * @return uuid
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "0c6439fd-9b16-3c2e-be6e-1086e0b9aa93", value = "policy uuid")
    
    public String getUuid() {
        return uuid;
    }


    public void setUuid(String uuid) {
        this.uuid = uuid;
    }


        public SubscriptionPolicyAllOfDTO policyName(String policyName) {
        
        this.policyName = policyName;
        return this;
        }

    /**
        * Name of policy
    * @return policyName
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "30PerMin", value = "Name of policy")
    
    public String getPolicyName() {
        return policyName;
    }


    public void setPolicyName(String policyName) {
        this.policyName = policyName;
    }


        public SubscriptionPolicyAllOfDTO displayName(String displayName) {
        
        this.displayName = displayName;
        return this;
        }

    /**
        * Display name of the policy
    * @return displayName
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "30PerMin", value = "Display name of the policy")
    
    public String getDisplayName() {
        return displayName;
    }


    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }


        public SubscriptionPolicyAllOfDTO description(String description) {
        
        this.description = description;
        return this;
        }

    /**
        * Description of the policy
    * @return description
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "Allows 30 request per minute", value = "Description of the policy")
    
    public String getDescription() {
        return description;
    }


    public void setDescription(String description) {
        this.description = description;
    }


        public SubscriptionPolicyAllOfDTO isDeployed(Boolean isDeployed) {
        
        this.isDeployed = isDeployed;
        return this;
        }

    /**
        * Indicates whether the policy is deployed successfully or not.
    * @return isDeployed
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(value = "Indicates whether the policy is deployed successfully or not.")
    
    public Boolean isIsDeployed() {
        return isDeployed;
    }


    public void setIsDeployed(Boolean isDeployed) {
        this.isDeployed = isDeployed;
    }


        public SubscriptionPolicyAllOfDTO tenantId(Integer tenantId) {
        
        this.tenantId = tenantId;
        return this;
        }

    /**
        * Throttling policy tenant domain id
    * @return tenantId
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "-1234", value = "Throttling policy tenant domain id")
    
    public Integer getTenantId() {
        return tenantId;
    }


    public void setTenantId(Integer tenantId) {
        this.tenantId = tenantId;
    }


        public SubscriptionPolicyAllOfDTO tenantDomain(String tenantDomain) {
        
        this.tenantDomain = tenantDomain;
        return this;
        }

    /**
        * Throttling policy tenant domain
    * @return tenantDomain
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "carbon.super", value = "Throttling policy tenant domain")
    
    public String getTenantDomain() {
        return tenantDomain;
    }


    public void setTenantDomain(String tenantDomain) {
        this.tenantDomain = tenantDomain;
    }


        public SubscriptionPolicyAllOfDTO defaultLimit(ThrottleLimitDTO defaultLimit) {
        
        this.defaultLimit = defaultLimit;
        return this;
        }

    /**
        * Get defaultLimit
    * @return defaultLimit
    **/
      @ApiModelProperty(required = true, value = "")
    
    public ThrottleLimitDTO getDefaultLimit() {
        return defaultLimit;
    }


    public void setDefaultLimit(ThrottleLimitDTO defaultLimit) {
        this.defaultLimit = defaultLimit;
    }


        public SubscriptionPolicyAllOfDTO rateLimitCount(Integer rateLimitCount) {
        
        this.rateLimitCount = rateLimitCount;
        return this;
        }

    /**
        * Burst control request count
    * @return rateLimitCount
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "10", value = "Burst control request count")
    
    public Integer getRateLimitCount() {
        return rateLimitCount;
    }


    public void setRateLimitCount(Integer rateLimitCount) {
        this.rateLimitCount = rateLimitCount;
    }


        public SubscriptionPolicyAllOfDTO rateLimitTimeUnit(String rateLimitTimeUnit) {
        
        this.rateLimitTimeUnit = rateLimitTimeUnit;
        return this;
        }

    /**
        * Burst control time unit
    * @return rateLimitTimeUnit
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "min", value = "Burst control time unit")
    
    public String getRateLimitTimeUnit() {
        return rateLimitTimeUnit;
    }


    public void setRateLimitTimeUnit(String rateLimitTimeUnit) {
        this.rateLimitTimeUnit = rateLimitTimeUnit;
    }


        public SubscriptionPolicyAllOfDTO subscriberCount(Integer subscriberCount) {
        
        this.subscriberCount = subscriberCount;
        return this;
        }

    /**
        * Number of subscriptions allowed
    * @return subscriberCount
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "10", value = "Number of subscriptions allowed")
    
    public Integer getSubscriberCount() {
        return subscriberCount;
    }


    public void setSubscriberCount(Integer subscriberCount) {
        this.subscriberCount = subscriberCount;
    }


        public SubscriptionPolicyAllOfDTO customAttributes(List<CustomAttributeDTO> customAttributes) {
        
        this.customAttributes = customAttributes;
        return this;
        }

    /**
        * Custom attributes added to the Subscription Throttling Policy 
    * @return customAttributes
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "[]", value = "Custom attributes added to the Subscription Throttling Policy ")
    
    public List<CustomAttributeDTO> getCustomAttributes() {
        return customAttributes;
    }


    public void setCustomAttributes(List<CustomAttributeDTO> customAttributes) {
        this.customAttributes = customAttributes;
    }


        public SubscriptionPolicyAllOfDTO stopOnQuotaReach(Boolean stopOnQuotaReach) {
        
        this.stopOnQuotaReach = stopOnQuotaReach;
        return this;
        }

    /**
        * This indicates the action to be taken when a user goes beyond the allocated quota. If checked, the user&#39;s requests will be dropped. If unchecked, the requests will be allowed to pass through. 
    * @return stopOnQuotaReach
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(value = "This indicates the action to be taken when a user goes beyond the allocated quota. If checked, the user's requests will be dropped. If unchecked, the requests will be allowed to pass through. ")
    
    public Boolean isStopOnQuotaReach() {
        return stopOnQuotaReach;
    }


    public void setStopOnQuotaReach(Boolean stopOnQuotaReach) {
        this.stopOnQuotaReach = stopOnQuotaReach;
    }


        public SubscriptionPolicyAllOfDTO billingPlan(String billingPlan) {
        
        this.billingPlan = billingPlan;
        return this;
        }

    /**
        * define whether this is Paid or a Free plan. Allowed values are FREE or COMMERCIAL. 
    * @return billingPlan
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(example = "FREE", value = "define whether this is Paid or a Free plan. Allowed values are FREE or COMMERCIAL. ")
    
    public String getBillingPlan() {
        return billingPlan;
    }


    public void setBillingPlan(String billingPlan) {
        this.billingPlan = billingPlan;
    }


        public SubscriptionPolicyAllOfDTO permissions(SubscriptionThrottlePolicyPermissionDTO permissions) {
        
        this.permissions = permissions;
        return this;
        }

    /**
        * Get permissions
    * @return permissions
    **/
        @javax.annotation.Nullable
      @ApiModelProperty(value = "")
    
    public SubscriptionThrottlePolicyPermissionDTO getPermissions() {
        return permissions;
    }


    public void setPermissions(SubscriptionThrottlePolicyPermissionDTO permissions) {
        this.permissions = permissions;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
        return true;
        }
        if (o == null || getClass() != o.getClass()) {
        return false;
        }
            SubscriptionPolicyAllOfDTO subscriptionPolicyAllOf = (SubscriptionPolicyAllOfDTO) o;
            return Objects.equals(this.policyId, subscriptionPolicyAllOf.policyId) &&
            Objects.equals(this.uuid, subscriptionPolicyAllOf.uuid) &&
            Objects.equals(this.policyName, subscriptionPolicyAllOf.policyName) &&
            Objects.equals(this.displayName, subscriptionPolicyAllOf.displayName) &&
            Objects.equals(this.description, subscriptionPolicyAllOf.description) &&
            Objects.equals(this.isDeployed, subscriptionPolicyAllOf.isDeployed) &&
            Objects.equals(this.tenantId, subscriptionPolicyAllOf.tenantId) &&
            Objects.equals(this.tenantDomain, subscriptionPolicyAllOf.tenantDomain) &&
            Objects.equals(this.defaultLimit, subscriptionPolicyAllOf.defaultLimit) &&
            Objects.equals(this.rateLimitCount, subscriptionPolicyAllOf.rateLimitCount) &&
            Objects.equals(this.rateLimitTimeUnit, subscriptionPolicyAllOf.rateLimitTimeUnit) &&
            Objects.equals(this.subscriberCount, subscriptionPolicyAllOf.subscriberCount) &&
            Objects.equals(this.customAttributes, subscriptionPolicyAllOf.customAttributes) &&
            Objects.equals(this.stopOnQuotaReach, subscriptionPolicyAllOf.stopOnQuotaReach) &&
            Objects.equals(this.billingPlan, subscriptionPolicyAllOf.billingPlan) &&
            Objects.equals(this.permissions, subscriptionPolicyAllOf.permissions);
    }

    @Override
    public int hashCode() {
        return Objects.hash(policyId, uuid, policyName, displayName, description, isDeployed, tenantId, tenantDomain, defaultLimit, rateLimitCount, rateLimitTimeUnit, subscriberCount, customAttributes, stopOnQuotaReach, billingPlan, permissions);
    }


@Override
public String toString() {
StringBuilder sb = new StringBuilder();
sb.append("class SubscriptionPolicyAllOfDTO {\n");
    sb.append("    policyId: ").append(toIndentedString(policyId)).append("\n");
    sb.append("    uuid: ").append(toIndentedString(uuid)).append("\n");
    sb.append("    policyName: ").append(toIndentedString(policyName)).append("\n");
    sb.append("    displayName: ").append(toIndentedString(displayName)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    isDeployed: ").append(toIndentedString(isDeployed)).append("\n");
    sb.append("    tenantId: ").append(toIndentedString(tenantId)).append("\n");
    sb.append("    tenantDomain: ").append(toIndentedString(tenantDomain)).append("\n");
    sb.append("    defaultLimit: ").append(toIndentedString(defaultLimit)).append("\n");
    sb.append("    rateLimitCount: ").append(toIndentedString(rateLimitCount)).append("\n");
    sb.append("    rateLimitTimeUnit: ").append(toIndentedString(rateLimitTimeUnit)).append("\n");
    sb.append("    subscriberCount: ").append(toIndentedString(subscriberCount)).append("\n");
    sb.append("    customAttributes: ").append(toIndentedString(customAttributes)).append("\n");
    sb.append("    stopOnQuotaReach: ").append(toIndentedString(stopOnQuotaReach)).append("\n");
    sb.append("    billingPlan: ").append(toIndentedString(billingPlan)).append("\n");
    sb.append("    permissions: ").append(toIndentedString(permissions)).append("\n");
sb.append("}");
return sb.toString();
}

/**
* Convert the given object to string with each line indented by 4 spaces
* (except the first line).
*/
private String toIndentedString(Object o) {
if (o == null) {
return "null";
}
return o.toString().replace("\n", "\n    ");
}

}

